

var WaveObject = function(OBJ, NORMAL, AXIS, HEIGHT, WIDTH, SPEED, VIDEO){
	
	this.axis = AXIS;
	this.width = WIDTH;
	this.obj = OBJ;
	this.geo = this.obj.geometry;
	this.doNormals = NORMAL;
	this.height = HEIGHT;
	this.video = VIDEO;
	this.speed = SPEED;
	this.fvNames = [ 'a', 'b', 'c', 'd' ];
	this.positions = [];
	this.ax = AXIS;
	this.axis = [];
	this.directions = [];
	this.phase = 0.0;
	this.ot = false;
	this.vertIndex = 0;
	
	this.init = function(){
		
		for( var i = 0; i < this.geo.faces.length; i ++ ) {
			
			var face = this.geo.faces[i];		
			
			var dr = [];
			var og = [];
			var ax = [];
			var rd = [];
				
			for(var k = 0; k<face.vertexNormals.length; k++){
					
				dr[k] = new THREE.Vector3(face.vertexNormals[k].x, face.vertexNormals[k].y, face.vertexNormals[k].z);
				og[k] = new THREE.Vector3(this.geo.vertices[face[this.fvNames[k]]].x, this.geo.vertices[face[this.fvNames[k]]].y, this.geo.vertices[face[this.fvNames[k]]].z);
				switch(this.ax){
					case "x":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].x*this.width);
					break;	
					case "y":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].y*this.width);
					break;	
					case "z":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;
					case "xy":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].x*this.geo.vertices[face[this.fvNames[k]]].y*this.width);
					break;
					case "xz":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].x*this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;
					case "yz":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].y*this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;	
					case "xyz":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].y*this.geo.vertices[face[this.fvNames[k]]].x*this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;	
						
				}
			}
			
			this.positions[i] = og;
			
			this.axis[i] = ax;	
			
			this.directions[i]  = dr;
			
		}		
	}
	
	this.update = function(){
		var data = this.getHeightData();
		
		for( var i = 0; i < this.geo.faces.length; i ++ ) {
				
			var face = this.geo.faces[i];
		
			var dr = this.directions[i];
			var og = this.positions[i];
			var ax = this.axis[i];
			
			for(var k = 0; k<face.vertexNormals.length; k++){
				
				var vd = data[this.vertIndex]*this.height;
				
				this.vertIndex++;
				
				//var vertPhase = (this.height*.5)+Math.sin(this.phase + ax[k])*(this.height*.5);
				var vertPhase = ((vd)*.5)+Math.sin(globalPhase + ax[k])*((vd)*.5);
			
				var thisVert = this.geo.vertices[face[this.fvNames[k]]];
				
				
				if(this.doNormals){
					
					thisVert.x = og[k].x + vertPhase * dr[k].x;
			
					thisVert.y = og[k].y + vertPhase * dr[k].y;
				
					thisVert.z = og[k].z + vertPhase * dr[k].z;
					
				}else{
				
					thisVert.x = og[k].x + vertPhase;
					
					thisVert.y = og[k].y + vertPhase;
				
					thisVert.z = og[k].z + vertPhase;	
				}
				
						
			}
			
		}
		
		this.phase+=this.speed;
		this.obj.geometry.verticesNeedUpdate = true;
		
		this.vertIndex = 0;
		
			
	}
	
	this.randomize = function(h, w, s){
		
		this.height = h;
		this.width = w;
		//this.speed = s;
		
		
		this.resetAxis();
		
		globalPhase = 0;
		
		//this.phase = 0.0;
	}
	
	
	this.resetAxis = function(){
		for( var i = 0; i < this.geo.faces.length; i ++ ) {
			
			var face = this.geo.faces[i];		
			
			var ax = [];
				
			for(var k = 0; k<face.vertexNormals.length; k++){
					

				switch(this.ax){
					case "x":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].x*this.width);
					break;	
					case "y":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].y*this.width);
					break;	
					case "z":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;
					case "xy":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].x*this.geo.vertices[face[this.fvNames[k]]].y*this.width);
					break;
					case "xz":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].x*this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;
					case "yz":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].y*this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;	
					case "xyz":
						ax[k] =  (this.geo.vertices[face[this.fvNames[k]]].y*this.geo.vertices[face[this.fvNames[k]]].x*this.geo.vertices[face[this.fvNames[k]]].z*this.width);
					break;	
						
				}
			}
			
			this.axis[i] = ax;	
				
		}			
	}
	
	
	this.getHeightData = function() {
		var canvas = document.createElement( 'canvas' );
		canvas.width = 128;
		canvas.height = 128;
		var context = canvas.getContext( '2d' );
		
	
		var size = 128 * 128, data = new Float32Array( size );
	
		context.drawImage(this.video, 0, 0);
	
		for ( var i = 0; i < size; i ++ ) {
			data[i] = 0;
		}
	
		var imgd = context.getImageData(0, 0, 128, 128);
		var pix = imgd.data;
	
		var j=0;
		for (var i = 0, n = pix.length; i < n; i += (1)) {
			var all = pix[i]+pix[i+1]+pix[i+2];
			data[j++] = all/30;
		}
	
		return data;
	}

}


